 /* dtos - convert Fortran program from double-precision to single-precision */
%{
#include "flex.h"
#include "fortran.h"
int debug = 0;				/* non-zero for debug output when */
					/* compiled with -DDEBUG */
int dp_output = 0;			/* single-precision output */
%}
		/* increase lex table sizes for lex */
%a 4000
%e 2000
%k 1500
%n  500
%o 6000
%p 4000

a	[aA]
b	[bB]
c	[cC]
d	[dD]
e	[eE]
f	[fF]
g	[gG]
h	[hH]
i	[iI]
j	[jJ]
k	[kK]
l	[lL]
m	[mM]
n	[nN]
o	[oO]
p	[pP]
q	[qQ]
r	[rR]
s	[sS]
t	[tT]
u	[uU]
v	[vV]
w	[wW]
x	[xX]
y	[yY]
z	[zZ]
				    /* digits with optional embedded blanks */
B		([0-9]|[0-9][0-9 ]*[0-9])
					/* decimal digit */
D		[0-9]
					/* floating-point exponent */
E		[DEde][-+]?{B}
					/* optional whitespace */
W		[ \t]*
					/* number */
N		{B}
%%
^[*Cc].*$			ECHO;	/* copy comments unchanged */

^\t[1-9]			{	/* handle tabbed continuation */
				    outstr("     ");
				    output(yytext[1]);
				}

^\t0 |
^\t				outstr("      "); /* handle tabbed initial */

^{W}{r}{e}{a}{l}"*"8		convert_declaration();

^{W}{r}{e}{a}{l}"*"4 |
^{W}{r}{e}{a}{l}/[^*a-zA-Z]	convert_declaration();

^{W}{d}{o}{u}{b}{l}{e}{W}{p}{r}{e}{c}{i}{s}{i}{o}{n}  convert_declaration();

^{W}{i}{m}{p}{l}{i}{c}{i}{t}{W}{r}{e}{a}{l}"*"8		convert_declaration();

^{W}{i}{m}{p}{l}{i}{c}{i}{t}{W}{r}{e}{a}{l}"*"4 |
^{W}{i}{m}{p}{l}{i}{c}{i}{t}{W}{r}{e}{a}{l}/[^*a-zA-Z]	convert_declaration();

^{W}{i}{m}{p}{l}{i}{c}{i}{t}{W}{d}{o}{u}{b}{l}{e}{W}{p}{r}{e}{c}{i}{s}{i}{o}{n}  convert_declaration();

^"     "[^ 0]			ECHO;	/* copy continuation line prefixes */

{N}{p}{N}*[A-Za-z]{N}"."{N}	ECHO;	/* copy FORMAT items intact */

{N}*[A-Za-z]{N}"."{N}		ECHO;	/* copy FORMAT items intact */

"."{n}{o}{t}"." |
"."{a}{n}{d}"." |
"."{x}{o}{r}"." |
"."{o}{r}"." |
"."{g}{e}"." |
"."{g}{t}"." |
"."{l}{e}"." |
"."{l}{t}"." |
"."{e}{q}"." |
"."{e}{q}{v}"." |
"."{n}{e}"." |
"."{n}{e}{q}"."			ECHO;	/* recognize logical operators */

{N}"."{N}*({W}{E})? |
{N}*"."{N}({W}{E})? |
{N}{W}{E}			convert_number() ;

{d}{a}{b}{s}/{W}"("		cvtstr("abs");	 /* handle name conversions */
{d}{a}{c}{o}{s}/{W}"("		cvtstr("acos");
{d}{a}{s}{i}{n}/{W}"("		cvtstr("asin");
{d}{a}{t}{a}{n}/{W}"("		cvtstr("atan");
{d}{a}{t}{a}{n}2/{W}"("		cvtstr("atan2");
{d}{b}{l}{e}/{W}"("		cvtstr("sngl");
{d}{c}{o}{s}/{W}"("		cvtstr("cos");
{d}{c}{o}{s}{h}/{W}"("		cvtstr("cosh");
{d}{d}{i}{m}/{W}"("		cvtstr("dim");
{d}{e}{x}{p}/{W}"("		cvtstr("exp");
{d}{f}{l}{o}{a}{t}/{W}"("	cvtstr("float");
{d}{i}{n}{t}/{W}"("		cvtstr("aint");
{d}{l}{o}{g}/{W}"("		cvtstr("alog");
{d}{l}{o}{g}10/{W}"("		cvtstr("alog10");
{d}{m}{a}{x}0/{W}"("		cvtstr("amax0");
{d}{m}{a}{x}1/{W}"("		cvtstr("amax1");
{d}{m}{i}{n}0/{W}"("		cvtstr("amin0");
{d}{m}{i}{n}1/{W}"("		cvtstr("amin1");
{d}{m}{o}{d}/{W}"("		cvtstr("amod");
{d}{n}{i}{n}{t}/{W}"("		cvtstr("anint");
{d}{s}{i}{g}{n}/{W}"("		cvtstr("sign");
{d}{s}{i}{n}/{W}"("		cvtstr("sin");
{d}{s}{i}{n}{h}/{W}"("		cvtstr("sinh");
{d}{s}{q}{r}{t}/{W}"("		cvtstr("sqrt");
{d}{t}{a}{n}/{W}"("		cvtstr("tan");
{d}{t}{a}{n}{h}/{W}"("		cvtstr("tanh");
{i}{d}{i}{n}{t}/{W}"("		cvtstr("int");
{i}{d}{n}{i}{n}{t}/{W}"("	cvtstr("nint");

{d}{r}{a}{n}{d}/{W}"("		cvtstr("rand");		/* common extensions */
{d}{1}{m}{a}{c}{h}/{W}"("	cvtstr("r1mach");

{B}{W}{h}			outhollerith();

'[^']*(''[^']*)*'		outquotedstring();

[A-Za-z][A-Za-z0-9]+ |
[0-9]+ |
\n |
.				ECHO;
%%

int our_input(void)
{
    return (input());
}
